<!--
 * @Author: zhp
 * @Date: 2023-02-14 15:02:26
 * @LastEditTime: 2023-05-22 16:25:01
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-form :model="dataForm" ref="dataForm" @keyup.enter.native="dataFormSubmitHandle()" label-width="150px">
    <el-form-item prop="client" :label="$t('gage.client')">
      <el-input v-model="dataForm.client" :placeholder="$t('gage.client')">
      </el-input>
    </el-form-item>
    <el-form-item prop="certificateNo" :label="$t('gage.certificateCode')">
      <el-input v-model="dataForm.certificateNo" :placeholder="$t('gage.certificateCode')">
      </el-input>
    </el-form-item>
    <el-form-item prop="verificationFee" :label="$t('gage.verificationFee')">
      <el-input v-model="dataForm.verificationFee" :placeholder="$t('gage.verificationFee')">
      </el-input>
    </el-form-item>
    <el-form-item prop="measure" :label="$t('gage.measure')">
      <el-select v-model="dataForm.measure" :placeholder="$t('gage.measure')">
        <el-option v-for="item in measureList" :key="item.id" :label="item.name" :value="item.id">
        </el-option>
      </el-select>
    </el-form-item>
    <el-form-item prop="gageId" :label="$t('gage.gageName')">
      <el-select v-model="dataForm.gageId" :placeholder="$t('gage.gageName')">
        <el-option v-for="item in gageList" :key="item.id" :label="item.name" :value="item.id">
        </el-option>
      </el-select>
    </el-form-item>
    <el-form-item prop="parityBit" :label="$t('gage.parityBit')">
      <el-radio-group v-model="dataForm.parityBit">
        <el-radio :label="0">内部校验</el-radio>
        <el-radio :label="1">外部校验</el-radio>
      </el-radio-group>
    </el-form-item>
    <el-form-item :label="$t('gage.inspectionTime')" prop="inspectionTime">
      <el-date-picker v-model="dataForm.inspectionTime" size="small" type="datetime" format='yyyy-MM-dd HH:mm:ss'
        valueFormat='yyyy-MM-ddTHH:mm:ss' :placeholder="$t('gage.inspectionTime')" />
    </el-form-item>
    <el-form-item prop="calibrationUnit" :label="$t('gage.calibrationUnit')">
      <el-input v-model="dataForm.calibrationUnit" :placeholder="$t('gage.calibrationUnit')">
      </el-input>
    </el-form-item>
    <el-form-item prop="calibrationDepartment" :label="$t('gage.calibrationDepartment')">
      <el-input v-model="dataForm.calibrationDepartment" :placeholder="$t('gage.calibrationDepartment')">
      </el-input>
    </el-form-item>
    <el-form-item prop="checker" :label="$t('gage.checker')">
      <el-select v-model="dataForm.checker" :placeholder="$t('gage.checker')">
        <el-option v-for="item in checkerList" :key="item.id" :label="item.name" :value="item.id">
        </el-option>
      </el-select>
    </el-form-item>
    <el-form-item prop="verificationResult" :label="$t('gage.verificationResult')">
      <el-input v-model="dataForm.verificationResult" :placeholder="$t('gage.verificationResult')">
      </el-input>
    </el-form-item>
    <el-form-item prop="remark" :label="$t('gage.remark')">
      <el-input v-model="dataForm.remark" :placeholder="$t('gage.remark')">
      </el-input>
    </el-form-item>
  </el-form>
</template>

<script>
import debounce from "lodash/debounce";
import basicAdd from "@/mixins/basic-add";
export default {
  mixins: [basicAdd],
  data() {
    return {
      urlOptions: {
        submitURL: "/gage/qmsGageVerification",
        infoURL: "/gage/qmsGageVerification/{ id }",
        getGageListURL: '/gage/qmsGage/page',
        getUserListURL: '/sys/user/page'
      },
      gageList: [],
      checkerList:[],
      gageTypeList: [],
      measureList: [
        {
          id: 0,
          name: 'a'
        },
        {
          id: 1,
          name: 'b'
        },
        {
          id: 2,
          name: 'c'
        }
      ],  
      departmentList: [],
      parameterList: [
        {
          id: 0,
          name: '基准'
        },
        {
          id: 1,
          name: '校验'
        },
      ],
      listQuery: {
        limit: 999,
        page: 1
      },
      visible: false,
      dataForm: {
        batchNumber:null,
        gageId: null,
        gageResumeId: null,
        id: null,
        measuringToolAccuracy: null,
        parameter: null,
        price: null,
        remark: null,
      },
    };
  },
  computed: {
    dataRule() {
      return {
        // dictLabel: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
        // dictValue: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
        // sort: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
      };
    },
  },
  mounted () {
    this.getData();
  },
  methods: {
    init(id, ) {
      this.dataForm.id = id || ""
      // console.log(11111)
      // this.dataForm.dictTypeId = dictTypeId || "";
      this.visible = true
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.dataForm.id) {
          this.getInfo()
        } else {
          // this.getCode()
        }
      });
    },
    getData() {
      this.$http
        .get(this.urlOptions.getGageListURL, {
          params:this.listQuery
        })
        .then(({ data: res }) => {
          if (res.code === 0) {
            console.log(res.data);
            this.gageList = res.data.list
          }
        })
        .catch(() => {
        })
      this.$http
        .get(this.urlOptions.getUserListURL, {
          params: this.listQuery
        })
        .then(({ data: res }) => {
          if (res.code === 0) {
            console.log(res.data);
            this.checkerList = res.data.list
          }
        })
        .catch(() => {
        })
    },
    // getCode() {
    //   this.$http.post(this.urlOptions.getCodeURL)
    //     .then(({ data: res }) => {
    //       if (res.code === 0) {
    //         console.log(res);
    //         this.dataForm.customSamplingCode = res.data
    //       }
    //     })
    //     .catch(() => {
    //     });
    // },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/gage/qmsGageVerification/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => { })
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](this.urlOptions.submitURL, this.dataForm)
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  console.log(1111);
                  this.visible = false;
                  this.$emit("successSubmit");
                },  
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
